<?php
/**
 * @version $Id: rssnevobo.php  2008-03-04 22:47 
 * @package     Joomla
 * @subpackage	Content
 * @copyright	Copyright (C) 2005 - 2007 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.

 * 0.2   changed heading 
 * 0.3 	 added programma function
 * 0.4.2 added filtering and points
 * 0.4.3 Het tonen van de stand van een poule incl. set en punten saldo
 *       Het tonen van het programma van een poule met de mogelijkheid om te filteren op een teamnaam
 *       Het tonen van de uitslagen van een poule met de mogelijkheid om te filteren op een teamnaam
 *       kleine layout aanpassingen
 * 0.4.4 wedstrijd in een kolom, en mogelijkheid om wedstrijdnummer niet te tonen, max aantal te tonen wedstrijden instelbaar
 * 0.5   geschikt gemaakt voor joomla 1.6
 * 0.5.1 Met dank aan Fred Peek aangepast aan de nieuwe Nevobo site
 * 0.5.2 sortering feeds aangepast
 * 0.5.3 styling
 * 0.5.4 datum uniform gemaakt, regular expressions toegepast. Wedstrijd nr verwijderd.
 * 0.5.5 uitbreiding styling, gebruik styling op basis van parameter instelling
 * 0.6.0 switchen van simplepie naar simplexml parser, waardoor quote's ook goed worden geparsed. &amp; wordt nu ook geaccepteerd in link
 * 0.6.1 aanpassing ivm lege programma's
 * 0.6.2 kleine aanpassing _callback functie
 * 0.6.3 allow url fopen workaround middels curl toegevoegd; Maand mei workaround toegevoegd
 * 0.6.5 final version, no fixes
 * 0.6.6 Ivm niet meer functioneren van de json api, de rss versie nieuw leven in geblazen
 * 0.6.7 wedstijd opgesplitst in uit en thuis, standen via de namespace opgehaald, refactoring
 * 0.8.0 omdat versie 0.7 is komen te vervallen door het ontbreken van de json api wordt de rss plugin verder ontwikkeld onder versie 0.8.x
 * 0.8.1 _checkfilter aangepast
 * 0.8.2 Verwerking van vervallen en niet gespeelde wedstrijden in de uitslagen
*/
defined( '_JEXEC' ) or die();

jimport('joomla.plugin.plugin');


class plgContentrssnevobo extends JPlugin
{
	/**
	 * @param	string	The context of the content being passed to the plugin.
	 * @param	object	The article object.  Note $article->text is also available
	 * @param	object	The article params
	 * @param	int		The 'page' number
	 */
	public function onContentPrepare($context, &$article, &$params, $page = 0)
	{
		// Simple performance check to determine whether bot should process further.
		if (JString::strpos($article->text, 'rssnevobo') === false) {
			return true;
		}
		$document = JFactory::getDocument();
		$mystyle = $this->params->get('stijl', '');
		$document->addStyleSheet(JURI::root().'plugins/content/rssnevobo/rssnevobo-'.$mystyle.'.css');		
		
		// Define the regular expression for the bot.
		$regex = "#{rssnevobo*(.*?)}(.*?){/rssnevobo}#s";
		
		// Perform the replacement.
		$article->text = preg_replace_callback($regex, array(&$this, '_replace'), $article->text);

		return true;
	}
	
	protected function _replace(&$matches)
	{
		jimport('joomla.utilities.utility');

		$args = JUtility::parseAttributes($matches[1]);
		$rssurl = strip_tags(trim($matches[2]));
		if (get_magic_quotes_gpc())
		{
			$rssurl = stripslashes($rssurl);
		}

		$rsscache = (int)JArrayHelper::getValue($args, 'cache', '10');
		$rssfilter = JArrayHelper::getValue($args, 'filter','');

		$rssaantal = (int)JArrayHelper::getValue($args,'aantal',999);
		if ($rssaantal == 0) { $rssaantal = 999;}
		$rsstype = (int)JArrayHelper::getValue($args,'type',0); // type: 0=stand; 1=programma
		$rssitems 			= 999;
		$content_buffer     = '';
		$params0 = '';
		$numstr = '';	
		if ($rssurl != "") { 			// only if array element is not empty

    		$content_buffer .= '<div style="direction: ' . 'ltr; ' . 'text-align: '. 'left;' .'">';
			$content_buffer .= '<table id="nevobotable">';	
			
			$content_buffer .= $this->_header($rsstype);

			// get RSS parsed object
			$rssurl = str_replace('&amp;', "&",$rssurl);   //robuuster gemaakt, editor vervangt & namelijk steeds door &amp; op de achtergrond			
			$xml= $this->_loadxml($rssurl);
		  	if ($xml) {
				$totalItems = count($xml->channel[0]->item);
				if ($totalItems >0) { 
					for ($i=0; $i<$totalItems;$i++) {		
		// ************************************** STAND ****************************						
						if ($rsstype==0){ 
						// nieuwe versie
							$namespaces = $xml->getNameSpaces(true);					
							$stand = $xml->channel[0]->children($namespaces['stand']);
							$text= '';
							$k=1;
							foreach ($stand->ranking as $ranking) {
								$rn = $ranking->nummer;
								if ($rn=='0') {$rn='';}
								$rt = $ranking->team;
								$rw = $ranking->wedstrijden;
								$rp = $ranking->punten;
								$rsv = $ranking->setsvoor;
								$rst = $ranking->setstegen;
								$rpv = $ranking->puntenvoor;
								$rpt = $ranking->puntentegen;
								$text .= '<tr '.$this->_isodd($k+1).'><td align="left">'.$rn.'</td><td align="left">'.$rt.'</td><td align="left">'.$rw.'</td><td align="left">'.$rp.'</td><td align="left">'.$rsv.'</td><td align="left">'.$rst.'</td><td align="left">'.$rpv.'</td><td align="left">'.$rpt.'</td></tr>';
								$k=$k+1;
							}
	
							$content_buffer .= $text;
		// *********************************** PROGRAMMA **************************								
						} else if ($rsstype==1 && $rssaantal>0) 
						{	
							$content_buffer .= "\n";
							$dummy = "Nog geen programma bekend";
							if ($this->_checkfilter($dummy, $xml->channel[0]->item[$i]->title)) {
								$rssaantal = $rssaantal - 1;
								$content_buffer .= '<tr '.$this->_isodd($rssaantal).'><td colspan="6">Er is geen programma bekend</td></tr>';
							}
							else if ($this->_checkfilter($rssfilter, $xml->channel[0]->item[$i]->title)) {
								$rssaantal = $rssaantal - 1;
								$content_buffer .= '<tr '.$this->_isodd($rssaantal).'>';						
						// pubDate
								$regex = '#(.*), (\d*) (.*) (\d*) (\d*):(\d*):(\d*) +(.*)#'; 
								$replacement = '<td>$2-$3-$4</td><td>$5:$6 uur</td>';
								$pubDateRepl = preg_replace_callback($regex, array(&$this, '_callback'), $xml->channel[0]->item[$i]->pubDate);
							if ($pubDateRepl == NULL) {$content_buffer .= '<td colspan="2">Onbekend</td>'; } else { $content_buffer .= $pubDateRepl;} // wedstrijd zonder planning
							
						//Title		
								$regex = "#(.*): (.*) - (.*)#";
								$replacement = '<td>$2</td><td>-</td><td>$3</td>';
								$content_buffer .=  preg_replace($regex, $replacement, $xml->channel[0]->item[$i]->title);						
							
						//Description  //<![CDATA[ Wedstrijd: 1000BD1B 71, Datum: , Speellocatie: ? ]]>
								$regex = "#Wedstrijd: (.*), Datum: (.*), Speellocatie: (.*)#";
								$replacement = '$3';
								$speelLocatie = preg_replace($regex, $replacement, $xml->channel[0]->item[$i]->description); 
								if ($speelLocatie == '?') { // onbekende speellocatie  
									$content_buffer .= '<td colspan="2"">onbekend</td></tr>';
								} 
								else {
									$regex = "#(.*), (.*), (\w*) (.*)#";
									$replacement = '<td><a href="https://www.google.com/maps/search/?api=1&query=$1,$2,$4" target="_blank" rel="noopener noreferrer"> $1</a></td><td>$4</td></tr>';   // https://www.google.com/maps/search/?api=1&query=
									$content_buffer .= preg_replace($regex, $replacement, $speelLocatie);
								}	
							} 
		// *********************************** UITSLAGEN ***************************	
	
						} else if ($rssaantal>0) { 						
							$content_buffer .= "\n";			
							$title = $xml->channel[0]->item[$i]->title;
							$dummy = "Speellocatie:";
							if ($this->_checkfilter($dummy, $xml->channel[0]->item[$i]->description)) {
								$rssaantal = $rssaantal - 1;
								$content_buffer .= '<tr '.$this->_isodd($rssaantal).'>';
								$regex = '#(.*), (\d*) (.*) (\d*) (\d*):(\d*):(\d*) +(.*)#'; 
								$replacement = '<td>$2-$3-$4</td>';
								$content_buffer .= preg_replace_callback($regex, array(&$this, '_callback'), $xml->channel[0]->item[$i]->pubDate);
								$dummy = "Vervallen";
								if ($this->_checkfilter($dummy, $title)) {
									$reason = "vervallen"; 
									$regex = '#Vervallen: (\d*) (.*). (\d*):(\d*): (.*) - (.*)#'; 
								} else { 
									$reason = "uitgesteld";
									$regex = '#(\d*) (.*). (\d*):(\d*): (.*) - (.*)#'; 
								}
								$replacement = '<td>$5</td><td>-</td><td>$6</td><td>'.$reason.'</td><td></td></tr>';
								$content_buffer .= preg_replace($regex, $replacement, $title);
							} else if ($title == 'Geen uitslagen bekend') {
								$rssaantal = $rssaantal - 1;		
								$content_buffer .= '<tr><td colspan="7">'.$title. '</td></tr>';
							} else if ($this->_checkfilter($rssfilter, $title)) 
							{
								$rssaantal = $rssaantal - 1;		
								$content_buffer .= '<tr '.$this->_isodd($rssaantal).'>';	
								$regex = '#(.*), (\d*) (.*) (\d*) (\d*):(\d*):(\d*) +(.*)#'; 
								$replacement = '<td>$2-$3-$4</td>';
								$content_buffer .= preg_replace_callback($regex, array(&$this, '_callback'), $xml->channel[0]->item[$i]->pubDate);					
								$regex = "#Wedstrijd: (.*) - (.*), Uitslag: (.*), Setstanden:( .*|)#";
								$replacement = '<td>$1</td><td>-</td><td>$2</td><td>$3</td><td>$4</td></tr>';
								$content_buffer .= preg_replace($regex, $replacement, $xml->channel[0]->item[$i]->description);

							}
						}
					}
				$content_buffer .= '</tbody>';
				} else {
				$content_buffer .= $this->_empty($rsstype);
				}
				
			} else {
				$content_buffer .= $this->_empty($rsstype);
			
			}		
			$content_buffer .= $this->_footer($rsstype);
			$content_buffer .= '</table>';
		}
		$content_buffer .= '</div>';
		return $content_buffer;
	}

	function _empty ($rt) { 
		if ($rt==0) {   // stand
			return '</tbody><tr><td colspan="8">Er is nog geen stand bekend</td></tr>';
		} else if ($rt==1) { // programma
			return '</tbody><tr><td colspan="7">Het programma is nog niet bekend</td></tr>';	
		} else { //rsstype = 2 uitslagen 
			return '</tbody><tr><td colspan="5">Er zijn nog geen uitslagen bekend</td></tr>';	
		}		
	}

	function _header($rt) {
		if ($rt==0) {         // stand
			return '<thead><tr><th class="topleft" colspan="2">Team</th><th align="left">Wedstrijden</th><th align="left">Punten</th><th align="left">Sets voor</th><th align="left">Sets tegen</th><th align="left">Punten voor</th><th class="topright" align="left">Punten tegen</th></tr></thead><tbody>';
		} else if ($rt==1) {  // programma
			return '<thead><tr><th class="topleft">Datum</th><th>Tijd</th><th colspan="3" align="center">Wedstrijd</th><th>Sporthal</th><th class="topright">Plaats</th></tr></thead><tbody>';	
		} else {              // uitslagen 
			return '<thead><tr>' . '<th class="topleft">Datum</th><th>Tijd</th><th colspan="3" align="center">Wedstrijd</th><th align="right">Uitslag</th><th class="topright">Setstanden</th></tr></thead><tbody>';	
		}		
	}

	function _footer($rt) {
		if ($rt==0) {   // stand
			return '<tfoot><tr><td class="botleft"></td><td></td><td></td><td></td><td></td><td></td><td></td><td class="botright"></td></tr></tfoot>';
		} else if ($rt==1) { // programma
			return '<tfoot><tr><td class="botleft"></td><td></td><td></td><td></td><td></td><td></td><td class="botright"></td></tr></tfoot>';	
		} else  //rsstype = 2 uitslagen 
		{
			return '<tfoot><tr><td class="botleft"></td><td></td><td></td><td></td><td></td><td></td><td class="botright"></td></tr></tfoot>';	
		}		
	}
	
	function _isodd ($nr) {
		$text = ''; 
		if (1 & $nr) { $text = 'class ="odd"'; } 
		return $text;
	}

// fixed in version 0.8.1
	function _checkfilter ($f, $t) { 				
		if ($f != '') {
			$pos = stripos ($t, $f);
			if ($pos !== false) {$pos = true;}
		} else {
			$pos = true;	
		}
		return $pos;
	}
		
	private function _callback ($matches) {
		switch ($matches[3]) {
			case 'Jan': $m = '01';
				break;
			case 'Feb': $m = '02';
				break;
			case 'Mar': $m = '03';
				break;
			case 'Apr': $m = '04';
				break;
			case 'Mei': $m = '05';
				break;
			case 'May': $m = '05';
				break;
			case 'Jun': $m = '06';
				break;
			case 'Jul': $m = '07';
				break;
			case 'Aug': $m = '08';
				break;
			case 'Sep': $m = '09';
				break;
			case 'Oct': $m = '10';
				break;
			case 'Nov': $m = '11';
				break;
			case 'Dec': $m = '12';
				break;
		}
		$text='<td>'.$matches[2].'-'.$m.'-'.$matches[4].'</td><td>'.$matches[5].':'.$matches[6].' uur</td>';
		return $text;
	}
	
	private function _loadxml ($this_url) {
		if (ini_get('allow_url_fopen') == true) {
			$this_xml = simplexml_load_file ($this_url);
		} else 
		
		if (function_exists ('curl_init')) {
			$ch = curl_init ($this_url);
			curl_setopt ($ch, CURLOPT_HEADER, false);
			curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
			$xml_raw = curl_exec ($ch);
			$this_xml = simplexml_load_string ($xml_raw);
		} else { echo "Om de feeds op te kunnen halen moet allow_url_fopen aan staan of moet er van curl gebruik gemaakt kunnen worden";} 
		return $this_xml;
	}
	
} // End Class